# all files / ol/source/ source.js

100% Statements 51/51
100% Branches 12/12
91.67% Functions 11/12
100% Lines 51/51

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    2031×

    1×
    1×
    1×
    1×
    1×

    1×

    669×

    669×

    669×

    669×

    669×

    669×

    1×

    1×
    704×
    11×
    693×
    2×
    691×
    40×
    40×
    40×
    132×
    132×
    6×

    126×

    40×

    651×

    1×

    1×
    537×

    1×
    305×

    1×
    2269×

    1×

    1×
    490×

    1×
    624×

    1×
    2×

    1×
    35×
    35×

    1×
    3×

    1×
    39×
    39×

     goog.provide('ol.source.Source');

    goog.require('ol');
    goog.require('ol.Attribution');
    goog.require('ol.Object');
    goog.require('ol.proj');
    goog.require('ol.source.State');

    /**
     * @classdesc
     * Abstract base class; normally only used for creating subclasses and not
     * instantiated in apps.
     * Base class for {@link ol.layer.Layer} sources.
     *
     * A generic `change` event is triggered when the state of the source changes.
     *
     * @constructor
     * @abstract
     * @extends {ol.Object}
     * @param {ol.SourceSourceOptions} options Source options.
     * @api
     */
    ol.source.Source = function(options) {

      ol.Object.call(this);

      /**
       * @private
       * @type {ol.proj.Projection}
       */
      this.projection_ = ol.proj.get(options.projection);

      /**
       * @private
       * @type {Array.<ol.Attribution>}
       */
      this.attributions_ = ol.source.Source.toAttributionsArray_(options.attributions);

      /**
       * @private
       * @type {string|olx.LogoOptions|undefined}
       */
      this.logo_ = options.logo;

      /**
       * @private
       * @type {ol.source.State}
       */
      this.state_ = options.state !== undefined ?
        options.state : ol.source.State.READY;

      /**
       * @private
       * @type {boolean}
       */
      this.wrapX_ = options.wrapX !== undefined ? options.wrapX : false;

    };
    ol.inherits(ol.source.Source, ol.Object);

    /**
     * Turns various ways of defining an attribution to an array of `ol.Attributions`.
     *
     * @param {ol.AttributionLike|undefined}
     *     attributionLike The attributions as string, array of strings,
     *     `ol.Attribution`, array of `ol.Attribution` or undefined.
     * @return {Array.<ol.Attribution>} The array of `ol.Attribution` or null if
     *     `undefined` was given.
     */
    ol.source.Source.toAttributionsArray_ = function(attributionLike) {
      if (typeof attributionLike === 'string') {
        return [new ol.Attribution({html: attributionLike})];
      } else if (attributionLike instanceof ol.Attribution) {
        return [attributionLike];
      } else if (Array.isArray(attributionLike)) {
        var len = attributionLike.length;
        var attributions = new Array(len);
        for (var i = 0; i < len; i++) {
          var item = attributionLike[i];
          if (typeof item === 'string') {
            attributions[i] = new ol.Attribution({html: item});
          } else {
            attributions[i] = item;
          }
        }
        return attributions;
      } else {
        return null;
      }
    };

    /**
     * @param {ol.Coordinate} coordinate Coordinate.
     * @param {number} resolution Resolution.
     * @param {number} rotation Rotation.
     * @param {number} hitTolerance Hit tolerance in pixels.
     * @param {Object.<string, boolean>} skippedFeatureUids Skipped feature uids.
     * @param {function((ol.Feature|ol.render.Feature)): T} callback Feature
     *     callback.
     * @return {T|undefined} Callback result.
     * @template T
     */
    ol.source.Source.prototype.forEachFeatureAtCoordinate = ol.nullFunction;

    /**
     * Get the attributions of the source.
     * @return {Array.<ol.Attribution>} Attributions.
     * @api
     */
    ol.source.Source.prototype.getAttributions = function() {
      return this.attributions_;
    };

    /**
     * Get the logo of the source.
     * @return {string|olx.LogoOptions|undefined} Logo.
     * @api
     */
    ol.source.Source.prototype.getLogo = function() {
      return this.logo_;
    };

    /**
     * Get the projection of the source.
     * @return {ol.proj.Projection} Projection.
     * @api
     */
    ol.source.Source.prototype.getProjection = function() {
      return this.projection_;
    };

    /**
     * @abstract
     * @return {Array.<number>|undefined} Resolutions.
     */
    ol.source.Source.prototype.getResolutions = function() {};

    /**
     * Get the state of the source, see {@link ol.source.State} for possible states.
     * @return {ol.source.State} State.
     * @api
     */
    ol.source.Source.prototype.getState = function() {
      return this.state_;
    };

    /**
     * @return {boolean|undefined} Wrap X.
     */
    ol.source.Source.prototype.getWrapX = function() {
      return this.wrapX_;
    };

    /**
     * Refreshes the source and finally dispatches a 'change' event.
     * @api
     */
    ol.source.Source.prototype.refresh = function() {
      this.changed();
    };

    /**
     * Set the attributions of the source.
     * @param {ol.AttributionLike|undefined} attributions Attributions.
     *     Can be passed as `string`, `Array<string>`, `{@link ol.Attribution}`,
     *     `Array<{@link ol.Attribution}>` or `undefined`.
     * @api
     */
    ol.source.Source.prototype.setAttributions = function(attributions) {
      this.attributions_ = ol.source.Source.toAttributionsArray_(attributions);
      this.changed();
    };

    /**
     * Set the logo of the source.
     * @param {string|olx.LogoOptions|undefined} logo Logo.
     */
    ol.source.Source.prototype.setLogo = function(logo) {
      this.logo_ = logo;
    };

    /**
     * Set the state of the source.
     * @param {ol.source.State} state State.
     * @protected
     */
    ol.source.Source.prototype.setState = function(state) {
      this.state_ = state;
      this.changed();
    };